package appmain;

import java.util.*;
import javax.microedition.midlet.*;
import menu.*;
import blade.*;
/**
* This class implements a midlet that reads and displays
* information from network locations based on a list of
* sources read from the Java Application Descriptor (jad) file.
* <p>$Id: UView.java,v 1.7 2003/01/21 00:22:07 finson Exp $
*/
public class UView extends QuitableMIDlet {
	/**
	* Construct the page manager needed to implement the midlet.  
	*/
	public UView() {
		pager = new PageMgr(this);
	}
	/**
	* Initialize the various data objects and related screens.
	* Called by the application management software to signal
	* the MIDlet that it has entered the Active state. 
	* In the Active state the MIDlet may hold resources.
	* The method will only be called when the MIDlet is
	* in the Paused state.  If any exceptions occur, we 
	* immediately transition to the destroyed state.
	*/
	public void startApp() {
		MenuPage root = new MenuPage("URL Viewer",true);
		pager.showRoot(root);
		Vector blade = buildBladePack();
		for (int i=0; i<blade.size(); i++) {
			Blade b = (Blade)blade.elementAt(i);
			URLPage p = new URLPage(b.getName(),b.getExternalForm());
			root.addChild(p);
		}
	}
	/**
	* Called by the application management software to 
	* signal the MIDlet to stop and enter the Paused state. 
	* In the Paused state the MIDlet must release shared 
	* resources and become quiescent. 
	* This method will only be called when the MIDlet is
	* in the Active state.
	*/
	protected void pauseApp() {
	}
	/**
	* Called by the application management software to 
	* signal the MIDlet to terminate and enter the Destroyed state.
	* In the destroyed state the MIDlet must release all resources
	* and save any persistent state. 
	* This method may be called from the Paused or Active states.
	* @param u If true, the MIDlet must cleanup and release all
	* resources. If false the MIDlet may throw MIDletStateChangeException
	* to indicate it does not want to be destroyed at this time.
	*/
	protected void destroyApp(boolean u) {
	}
	/**
	* Build a list of the URLs we know about.
	* We expect that there are one or more 
	* Blades defined in the Java Application 
	* Descriptor (jad) file using the parameters Blade-Name-n 
	* and the associated Blade-URL-n.
	* @return an ArrayList containing a Blade object for each
	* name/url pair defined in the jad.
	*/
	private Vector buildBladePack() {
		String bName;
		String bURL;
		
		Vector bladePack = new Vector();
		
		int idx = 1;
		do {
			String tag = Integer.toString(idx);
			bName = this.getAppProperty("Blade-Name-"+tag);
			if (bName == null) break;
			bURL = this.getAppProperty("Blade-URL-"+tag);
			if (bURL == null) break;
			bladePack.addElement(new Blade(bName,bURL));
			idx++;
		} while (true);
		return bladePack;
	}
	
	//--------------------------------------------------------------------
	
	/** the Page manager for this midlet */
	private PageMgr pager;

}
